/*
 * iSCSI driver for Linux
 * Copyright (C) 2001 Cisco Systems, Inc.
 * maintained by linux-iscsi-devel@lists.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * See the file COPYING included with this distribution for more details.
 *
 * $Id: iscsi-common.h,v 1.2 2004/08/23 07:20:12 krishmnc Exp $
 *
 * Common info needed by various kernel modules
 */
 
#ifndef ISCSI_COMMON_H_
#define ISCSI_COMMON_H_

#include <linux/blkdev.h>
#include <linux/random.h>
#define AS_ERROR  KERN_ERR
#define AS_NOTICE KERN_NOTICE
#define AS_INFO   KERN_INFO
#define AS_DEBUG  KERN_DEBUG
#define logmsg(level, fmt, args...) \
	printk(level "iSCSI: "fmt, ##args)
#define debugmsg(level, fmt, arg...)  do { } while (0)
#define iscsi_strtoul simple_strtoul
#define SETSG(sg, p,l)                                  \
        {                                               \
                (sg).page = virt_to_page((p));          \
                (sg).offset = offset_in_page((p));      \
                (sg).length = (l);                      \
        }

#endif
